/////////////////////////////////////////////////////////////////////////////
// Bdd.cpp
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2001 Cricri  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on More FTC & Azertix 9c Those portions are
// Copyright Gloup & Azertix (C) 1999/2000 
//
/////////////////////////////////////////////////////////////////////////////

#include "CriCrack.h"
#include <commctrl.h>
#include "../../k!tv-xp/versionno.h"

#define TXT_ABOUT	"Plugin Cricrack " \
					CRICRACK_VERSION \
					" pour K!TV XP " \
					STRPRODUCTVER \
					" Copyright (C) 2002 Cricri"

extern QuenotteTV_VideoPlugin	sVP;
extern FTC_CRACK				sCtx;



/* ---------------------- External Functions declaration ------------------- */
void misc_load_def( void);
void locale_Bdd( HWND          hDlg,           // handle to Bdd
                 HINSTANCE     hModule,        // handle to module ( Dll )
                 WORD          wLangID         // language identifier
);

/* -------------------------------------------------------------------------- */


/* -------------------------------------------------------------------------- */
BOOL APIENTRY bdd_about_proc( HWND hDlg, UINT message, UINT wParam, LONG lParam)
/* -------------------------------------------------------------------------- */
{
   
	switch ( message) {

        case WM_INITDIALOG:
			SetWindowText( hDlg, TXT_ABOUT);
			break;

        case WM_COMMAND:
			if ( (LOWORD( wParam) == IDOK ) || (LOWORD( wParam) == IDCANCEL )) {
				EndDialog( hDlg, TRUE);
			}
			break;
    }

	return( FALSE);

	UNREFERENCED_PARAMETER( lParam);

}




/* -------------------------------------------------------------------------- */
BOOL APIENTRY bdd_setup_proc( HWND hDlg, UINT message, UINT wParam, LONG lParam)
/* -------------------------------------------------------------------------- */
{
	HWND	hWinOffsetX = GetDlgItem( hDlg, IDC_SLIDER_OFFSETX );
	HWND	hWinNbrPt = GetDlgItem( hDlg, IDC_SLIDER_NBRPT );
	HWND	hWinBLevelP = GetDlgItem( hDlg, IDC_SLIDER_CORBLACKP );
	HWND	hWinCorP = GetDlgItem( hDlg, IDC_SLIDER_CORP );
	HWND	hWinBLevelM = GetDlgItem( hDlg, IDC_SLIDER_CORBLACKM );
	HWND	hWinCorM = GetDlgItem( hDlg, IDC_SLIDER_CORM );
	HWND	hWinLevel = GetDlgItem( hDlg, IDC_SLIDER_LEVEL );


	static int		nOldOffsetX, nOldCorBlackP, nOldCorBlackM, nOldCorPlus;
	static int		nOldCorMoins, nOldFullField, nOldNbrPt, nOldLumLevel;
	static int		nOldAutoProcessVideo;
    bool			bCheckBtn;
	static FCT_T	eOldModeFct = sCtx.sCmd.eModeFct;
	static DEC_T	eOldModeDec = sCtx.sCmd.eModeDec;
	static char		szOldModeFct[32], szOldModeDec[32];


	switch ( message) {

	case WM_INITDIALOG :
        
        locale_Bdd( hDlg, sVP.hDllInstance, sVP.LangID);

        /* sliders	*/
		SendMessage( hWinOffsetX, TBM_SETRANGEMAX, TRUE, 13 );	// set max slider position
		SendMessage( hWinOffsetX, TBM_SETPOS, TRUE, sCtx.nOffsetX );	// set slider position
		SetDlgItemInt( hDlg, IDC_DYN_OFFSETX, sCtx.nOffsetX, FALSE); // set current position (unsigned)
		nOldOffsetX = sCtx.nOffsetX;

		SendMessage( hWinNbrPt, TBM_SETRANGEMAX, TRUE, 26 );	// set max slider position
		SendMessage( hWinNbrPt, TBM_SETRANGEMIN, TRUE, 1 );	// set min slider position
		SendMessage( hWinNbrPt, TBM_SETPOS, TRUE, sCtx.sStatus.nNbrPt);	// set slider position
		SetDlgItemInt( hDlg, IDC_DYN_NBRPT, sCtx.sStatus.nNbrPt, FALSE); // set current position (unsigned)
		nOldNbrPt = sCtx.sStatus.nNbrPt;

		SendMessage( hWinBLevelP, TBM_SETRANGEMAX, TRUE, 14 );	// set max slider position
		SendMessage( hWinBLevelP, TBM_SETPOS, TRUE, sCtx.nCorBlackP );	// set slider position
		SetDlgItemInt( hDlg, IDC_DYN_CORBLACKP, sCtx.nCorBlackP, FALSE); // set current position (unsigned)
		nOldCorBlackP = sCtx.nCorBlackP;

		SendMessage( hWinBLevelM, TBM_SETRANGEMAX, TRUE, 14 );	// set max slider position
		SendMessage( hWinBLevelM, TBM_SETPOS, TRUE, sCtx.nCorBlackM );	// set slider position
		SetDlgItemInt( hDlg, IDC_DYN_CORBLACKM, sCtx.nCorBlackM, FALSE); // set current position (unsigned)
		nOldCorBlackM = sCtx.nCorBlackM;

		SendMessage( hWinCorP, TBM_SETRANGEMAX, TRUE, 12 );	// set max slider position
		SendMessage( hWinCorP, TBM_SETPOS, TRUE, sCtx.nCorPlus );	// set slider position
		SetDlgItemInt( hDlg, IDC_DYN_CORP, sCtx.nCorPlus, FALSE); // set current position (unsigned)
		nOldCorPlus = sCtx.nCorPlus;

		SendMessage( hWinCorM, TBM_SETRANGEMAX, TRUE, 12 );	// set max slider position
		SendMessage( hWinCorM, TBM_SETPOS, TRUE, sCtx.nCorMoins );	// set slider position
		SetDlgItemInt( hDlg, IDC_DYN_CORM, sCtx.nCorMoins, FALSE); // set current position (unsigned)
		nOldCorMoins = sCtx.nCorMoins;

		/*	Level	*/
		SendMessage( hWinLevel, TBM_SETRANGEMAX, TRUE, 50 );	// set max slider position
		SendMessage( hWinLevel, TBM_SETPOS, TRUE, sCtx.nLumLevelAdd );	// set slider position
		SetDlgItemInt( hDlg, IDC_DYN_LEVEL, sCtx.nLumLevelAdd, FALSE); // set current position (unsigned)
		nOldLumLevel = sCtx.nLumLevelAdd;

		/* check buttons DEC_MODE	*/
		CheckDlgButton( hDlg, IDC_RADIO_DEC_AUTO, sCtx.sCmd.eModeDec == DEC_AUTO);
		CheckDlgButton( hDlg, IDC_RADIO_DEC_AZ, sCtx.sCmd.eModeDec & DEC_AZ
												&& sCtx.sCmd.eModeDec != DEC_AUTO);
		CheckDlgButton( hDlg, IDC_RADIO_DEC_CR, sCtx.sCmd.eModeDec & DEC_CR
												&& sCtx.sCmd.eModeDec != DEC_AUTO);

		CheckDlgButton( hDlg, IDC_CHECK_AZ_START, sCtx.sCmd.eModeDec & DEC_AZ_START);

		CheckDlgButton( hDlg, IDC_CHECK_CR_CORP, sCtx.sCmd.eModeDec & DEC_CR_CORP);
		CheckDlgButton( hDlg, IDC_CHECK_CR_CORPCOR, sCtx.sCmd.eModeDec & DEC_CR_CORPC);
		eOldModeDec = sCtx.sCmd.eModeDec;
		strcpy( szOldModeDec, sCtx.szDec);

		/*	Check FullField	*/
		CheckDlgButton( hDlg, IDC_CHECK_FULLFIELD, sVP.FullField);
		nOldFullField = sVP.FullField;

		CheckDlgButton( hDlg, IDC_CHECK_DET_AUTO, sVP.AutoProcessVideo);
		nOldAutoProcessVideo = sVP.AutoProcessVideo;

		/* disable windows item according to check buttons status	*/
		if ( sCtx.sCmd.eModeDec == DEC_AUTO) {
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_AZ_START), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_CR_CORP), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_CR_CORPCOR), FALSE);

			EnableWindow( hWinBLevelM, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORBLACKM), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORBLACKM), FALSE);
			EnableWindow( hWinCorM, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORM), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORM), FALSE);

		} else if ( sCtx.sCmd.eModeDec & DEC_AZ) {
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_AZ_START), TRUE);
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_CR_CORP), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_CR_CORPCOR), FALSE);

			EnableWindow( hWinBLevelM, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORBLACKM), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORBLACKM), FALSE);
			EnableWindow( hWinCorM, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORM), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORM), FALSE);

		} else if ( sCtx.sCmd.eModeDec & DEC_CR) {
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_AZ_START), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_CR_CORP), TRUE);
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_CR_CORPCOR), TRUE);

			EnableWindow( hWinBLevelM, TRUE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORBLACKM), TRUE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORBLACKM), TRUE);
			EnableWindow( hWinCorM, TRUE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORM), TRUE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORM), TRUE);
		}

		if ( sCtx.sCmd.eModeDec & ~DEC_CR_CORP || sCtx.sCmd.eModeDec & ~DEC_CR) {
			EnableWindow( hWinBLevelP, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORBLACKP), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORBLACKP), FALSE);
			EnableWindow( hWinCorP, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORP), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORP), FALSE);
		}

		if ( !sVP.FullField) {
			EnableWindow( GetDlgItem( hDlg, IDC_RADIO_FCT_AUTO), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_RADIO_FCT_TT), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_RADIO_FCT_TE), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_VIAFIX), FALSE);
		} else {
			CheckDlgButton( hDlg, IDC_RADIO_FCT_AUTO, sCtx.sCmd.eModeFct == FCT_AUTO);
			CheckDlgButton( hDlg, IDC_RADIO_FCT_TT, sCtx.sCmd.eModeFct == FCT_TT);
			CheckDlgButton( hDlg, IDC_RADIO_FCT_TE, sCtx.sCmd.eModeFct == FCT_TE);
		}
		eOldModeFct = sCtx.sCmd.eModeFct;
		strcpy( szOldModeFct, sCtx.szFct);

		/* Level	*/
		if ( sCtx.sCmd.eModeDec & ~DEC_AZ_START) {
			EnableWindow( hWinLevel, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_LEVEL), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_LEVEL), FALSE);
		}
		break;

	case WM_HSCROLL :

        if ( (HWND)lParam == hWinOffsetX) {
			sCtx.nOffsetX = SendMessage( hWinOffsetX, TBM_GETPOS, 0, 0 ); // get current slider position
			SetDlgItemInt( hDlg, IDC_DYN_OFFSETX, sCtx.nOffsetX, FALSE);	// set current position (unsigned)
		} else if ( (HWND)lParam == hWinBLevelP) {
			sCtx.nCorBlackP = SendMessage( hWinBLevelP, TBM_GETPOS, 0, 0 );
			SetDlgItemInt( hDlg, IDC_DYN_CORBLACKP, sCtx.nCorBlackP, FALSE);
		} else if ( (HWND)lParam == hWinBLevelM) {
			sCtx.nCorBlackM = SendMessage( hWinBLevelM, TBM_GETPOS, 0, 0 );
			SetDlgItemInt( hDlg, IDC_DYN_CORBLACKM, sCtx.nCorBlackM, FALSE);
		} else if ( (HWND)lParam == hWinCorP) {
			sCtx.nCorPlus = SendMessage( hWinCorP, TBM_GETPOS, 0, 0 );
			SetDlgItemInt( hDlg, IDC_DYN_CORP, sCtx.nCorPlus, FALSE);
		} else if ( (HWND)lParam == hWinCorM) {
			sCtx.nCorMoins = SendMessage( hWinCorM, TBM_GETPOS, 0, 0 );
			SetDlgItemInt( hDlg, IDC_DYN_CORM, sCtx.nCorMoins, FALSE);
		} else if ( (HWND)lParam == hWinNbrPt) {
			sCtx.sStatus.nNbrPt = SendMessage( hWinNbrPt, TBM_GETPOS, 0, 0 );
			SetDlgItemInt( hDlg, IDC_DYN_NBRPT, sCtx.sStatus.nNbrPt, FALSE);
		} else if ( (HWND)lParam == hWinLevel) {
			sCtx.nLumLevelAdd = SendMessage( hWinLevel, TBM_GETPOS, 0, 0 );
			SetDlgItemInt( hDlg, IDC_DYN_LEVEL, sCtx.nLumLevelAdd, FALSE);
		}
		break;

	case WM_VSCROLL :
		break;

	case WM_COMMAND :

		switch ( wParam) {
		
		/* working mode management	*/
		case IDC_RADIO_FCT_AUTO :
			eOldModeFct = sCtx.sCmd.eModeFct = FCT_AUTO;
			strcpy( sCtx.szFct, SZ_FCT_AUTO);
			break;

		case IDC_RADIO_FCT_TT :
			eOldModeFct = sCtx.sCmd.eModeFct = FCT_TT;
			strcpy( sCtx.szFct, SZ_FCT_TT);
			break;

		case IDC_RADIO_FCT_TE :
			eOldModeFct = sCtx.sCmd.eModeFct = FCT_TE;
			strcpy( sCtx.szFct, SZ_FCT_TE);
			break;

		/* decoding mode management	*/
		case IDC_RADIO_DEC_AUTO :
//			if ( IsDlgButtonChecked( hDlg, IDC_RADIO_DEC_AZ)) {
			sCtx.sCmd.eModeDec = DEC_AUTO;
			strcpy( sCtx.szDec, SZ_DEC_AUTO);
			CheckDlgButton( hDlg, IDC_CHECK_AZ_START, FALSE);
			CheckDlgButton( hDlg, IDC_CHECK_CR_CORP, FALSE);
			CheckDlgButton( hDlg, IDC_CHECK_CR_CORPCOR, FALSE);

			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_AZ_START), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_CR_CORP), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_CR_CORPCOR), FALSE);

			EnableWindow( hWinBLevelP, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORBLACKP), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORBLACKP), FALSE);
			EnableWindow( hWinCorP, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORP), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORP), FALSE);
			EnableWindow( hWinBLevelM, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORBLACKM), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORBLACKM), FALSE);
			EnableWindow( hWinCorM, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORM), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORM), FALSE);

			break;

		case IDC_RADIO_DEC_AZ :
			sCtx.sCmd.eModeDec = DEC_AZ;
			strcpy( sCtx.szDec, SZ_DEC_AZ);
			CheckDlgButton( hDlg, IDC_CHECK_AZ_START, FALSE);
			CheckDlgButton( hDlg, IDC_CHECK_CR_CORP, FALSE);
			CheckDlgButton( hDlg, IDC_CHECK_CR_CORPCOR, FALSE);

			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_AZ_START), TRUE);
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_CR_CORP), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_CR_CORPCOR), FALSE);

			EnableWindow( hWinBLevelP, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORBLACKP), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORBLACKP), FALSE);
			EnableWindow( hWinCorP, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORP), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORP), FALSE);
			EnableWindow( hWinBLevelM, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORBLACKM), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORBLACKM), FALSE);
			EnableWindow( hWinCorM, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORM), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORM), FALSE);

			break;

		case IDC_CHECK_AZ_START :
			if ( IsDlgButtonChecked( hDlg, IDC_CHECK_AZ_START)) {
				EnableWindow( hWinLevel, TRUE);
				EnableWindow( GetDlgItem( hDlg, IDC_DYN_LEVEL), TRUE);
				EnableWindow( GetDlgItem( hDlg, IDC_STATIC_LEVEL), TRUE);
				sCtx.sCmd.eModeDec = DEC_AZ_START;
				strcpy( sCtx.szDec, SZ_DEC_AZ_START);
			} else {
				EnableWindow( hWinLevel, FALSE);
				EnableWindow( GetDlgItem( hDlg, IDC_DYN_LEVEL), FALSE);
				EnableWindow( GetDlgItem( hDlg, IDC_STATIC_LEVEL), FALSE);
				sCtx.sCmd.eModeDec = DEC_AZ;
				strcpy( sCtx.szDec, SZ_DEC_AZ);
			}
			break;

		case IDC_RADIO_DEC_CR :
			sCtx.sCmd.eModeDec = DEC_CR;
			strcpy( sCtx.szDec, SZ_DEC_CR);
			CheckDlgButton( hDlg, IDC_CHECK_AZ_START, FALSE);
			CheckDlgButton( hDlg, IDC_CHECK_CR_CORP, FALSE);
			CheckDlgButton( hDlg, IDC_CHECK_CR_CORPCOR, FALSE);

			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_AZ_START), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_CR_CORP), TRUE);
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_CR_CORPCOR), FALSE);

			EnableWindow( hWinBLevelP, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORBLACKP), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORBLACKP), FALSE);
			EnableWindow( hWinCorP, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORP), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORP), FALSE);

			EnableWindow( hWinBLevelM, TRUE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORBLACKM), TRUE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORBLACKM), TRUE);
			EnableWindow( hWinCorM, TRUE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORM), TRUE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORM), TRUE);

			break;

		case IDC_CHECK_CR_CORP :
			if ( IsDlgButtonChecked( hDlg, IDC_CHECK_CR_CORP)) {
				sCtx.sCmd.eModeDec = DEC_CR_CORP;
				strcpy( sCtx.szDec, SZ_DEC_CR_CORP);
			} else {
				sCtx.sCmd.eModeDec = DEC_CR;
				strcpy( sCtx.szDec, SZ_DEC_CR);
			}
			CheckDlgButton( hDlg, IDC_CHECK_CR_CORPCOR, FALSE);
			EnableWindow( hWinBLevelP, sCtx.sCmd.eModeDec & DEC_CR_CORP);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORBLACKP), sCtx.sCmd.eModeDec & DEC_CR_CORP);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORBLACKP), sCtx.sCmd.eModeDec & DEC_CR_CORP);
			EnableWindow( hWinCorP, sCtx.sCmd.eModeDec & DEC_CR_CORP);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORP), sCtx.sCmd.eModeDec & DEC_CR_CORP);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORP), sCtx.sCmd.eModeDec & DEC_CR_CORP);

			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_CR_CORPCOR), sCtx.sCmd.eModeDec & DEC_CR_CORP);
			break;

		case IDC_CHECK_CR_CORPCOR :
			if ( IsDlgButtonChecked( hDlg, IDC_CHECK_CR_CORPCOR)) {
				sCtx.sCmd.eModeDec = DEC_CR_CORPC;
				strcpy( sCtx.szDec, SZ_DEC_CR_CORPC);
			} else {
				sCtx.sCmd.eModeDec = DEC_CR_CORP;
				strcpy( sCtx.szDec, SZ_DEC_CR_CORP);
			}
			break;

		case IDC_CHECK_FULLFIELD :
			bCheckBtn = IsDlgButtonChecked( hDlg, IDC_CHECK_FULLFIELD)
						? true : false;
			EnableWindow( GetDlgItem( hDlg, IDC_RADIO_FCT_AUTO), bCheckBtn);
			EnableWindow( GetDlgItem( hDlg, IDC_RADIO_FCT_TT), bCheckBtn);
			EnableWindow( GetDlgItem( hDlg, IDC_RADIO_FCT_TE), bCheckBtn);
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_VIAFIX), bCheckBtn);
			if ( bCheckBtn) {
				CheckDlgButton( hDlg, IDC_RADIO_FCT_AUTO, eOldModeFct == FCT_AUTO);
				CheckDlgButton( hDlg, IDC_RADIO_FCT_TT, eOldModeFct == FCT_TT);
				CheckDlgButton( hDlg, IDC_RADIO_FCT_TE, eOldModeFct == FCT_TE);
			}
			break;

		case IDC_OK :
			sVP.FullField = IsDlgButtonChecked( hDlg, IDC_CHECK_FULLFIELD);
			if ( nOldFullField != sVP.FullField) {
				if ( !sVP.FullField) {
					eOldModeFct = sCtx.sCmd.eModeFct;
					sCtx.sCmd.eModeFct = FCT_TT;
				} else {
					sCtx.sCmd.eModeFct = eOldModeFct;
				}
				SendMessage( sVP.hwndParent, WM_COMMAND, 360, 0);
			}

			sVP.AutoProcessVideo = IsDlgButtonChecked( hDlg, IDC_CHECK_DET_AUTO);
			EndDialog( hDlg, TRUE);
			break;

		case IDC_CANCEL :
			// cancel all modifications
			sCtx.nOffsetX = nOldOffsetX;
			sCtx.sStatus.nNbrPt = nOldNbrPt;
			sCtx.nCorBlackP = nOldCorBlackP;
			sCtx.nCorBlackM = nOldCorBlackM;
			sCtx.nCorPlus = nOldCorPlus;
			sCtx.nCorMoins = nOldCorMoins;
			sCtx.nLumLevelAdd = nOldLumLevel;
			sCtx.sCmd.eModeDec = eOldModeDec;
			sCtx.sCmd.eModeFct = eOldModeFct;
			strcpy( sCtx.szDec, szOldModeDec);
			strcpy( sCtx.szFct, szOldModeFct);
			sVP.FullField = nOldFullField;
			sVP.AutoProcessVideo = nOldAutoProcessVideo;

			EndDialog( hDlg, TRUE);
			break;

		case IDC_DEFAULT :
			// 
			misc_load_def();

			SendMessage( hWinOffsetX, TBM_SETPOS, TRUE, sCtx.nOffsetX );	// set slider position
			SetDlgItemInt( hDlg, IDC_DYN_OFFSETX, sCtx.nOffsetX, FALSE); // set current position (unsigned)
			SendMessage( hWinNbrPt, TBM_SETPOS, TRUE, sCtx.sStatus.nNbrPt);	// set slider position
			SetDlgItemInt( hDlg, IDC_DYN_NBRPT, sCtx.sStatus.nNbrPt, FALSE); // set current position (unsigned)
			SendMessage( hWinBLevelP, TBM_SETPOS, TRUE, sCtx.nCorBlackP );	// set slider position
			SetDlgItemInt( hDlg, IDC_DYN_CORBLACKP, sCtx.nCorBlackP, FALSE); // set current position (unsigned)
			SendMessage( hWinBLevelM, TBM_SETPOS, TRUE, sCtx.nCorBlackM );	// set slider position
			SetDlgItemInt( hDlg, IDC_DYN_CORBLACKM, sCtx.nCorBlackM, FALSE); // set current position (unsigned)
			SendMessage( hWinCorP, TBM_SETPOS, TRUE, sCtx.nCorPlus );	// set slider position
			SetDlgItemInt( hDlg, IDC_DYN_CORP, sCtx.nCorPlus, FALSE); // set current position (unsigned)
			SendMessage( hWinCorM, TBM_SETPOS, TRUE, sCtx.nCorMoins );	// set slider position
			SetDlgItemInt( hDlg, IDC_DYN_CORM, sCtx.nCorMoins, FALSE); // set current position (unsigned)
			SendMessage( hWinLevel, TBM_SETPOS, TRUE, sCtx.nLumLevelAdd );	// set slider position
			SetDlgItemInt( hDlg, IDC_DYN_LEVEL, sCtx.nLumLevelAdd, FALSE); // set current position (unsigned)

			CheckDlgButton( hDlg, IDC_RADIO_DEC_AUTO, 
							sCtx.sCmd.eModeDec == DEC_AUTO);
			CheckDlgButton( hDlg, IDC_RADIO_DEC_AZ, 
							sCtx.sCmd.eModeDec & DEC_AZ
							&& sCtx.sCmd.eModeDec != DEC_AUTO);
			CheckDlgButton( hDlg, IDC_RADIO_DEC_CR,
							sCtx.sCmd.eModeDec & DEC_CR
							&& sCtx.sCmd.eModeDec != DEC_AUTO);

			CheckDlgButton( hDlg, IDC_RADIO_FCT_AUTO, 
							sCtx.sCmd.eModeFct == FCT_AUTO);
			CheckDlgButton( hDlg, IDC_RADIO_FCT_TT, 
							sCtx.sCmd.eModeFct == FCT_TT);
			CheckDlgButton( hDlg, IDC_RADIO_FCT_TE, 
							sCtx.sCmd.eModeFct == FCT_TE);

			CheckDlgButton( hDlg, IDC_CHECK_AZ_START, sCtx.sCmd.eModeDec & DEC_AZ_START);

			CheckDlgButton( hDlg, IDC_CHECK_CR_CORP, sCtx.sCmd.eModeDec & DEC_CR_CORP);
			CheckDlgButton( hDlg, IDC_CHECK_CR_CORPCOR, sCtx.sCmd.eModeDec & DEC_CR_CORPC);
			CheckDlgButton( hDlg, IDC_CHECK_FULLFIELD, sVP.FullField);
			CheckDlgButton( hDlg, IDC_CHECK_DET_AUTO, sVP.AutoProcessVideo);

			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_AZ_START), 
										sCtx.sCmd.eModeDec & DEC_AZ_START);
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_CR_CORP), 
										sCtx.sCmd.eModeDec & DEC_CR_CORP);
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_CR_CORPCOR), FALSE);

			EnableWindow( hWinBLevelP, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORBLACKP), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORBLACKP), FALSE);
			EnableWindow( hWinCorP, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORP), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORP), FALSE);

			EnableWindow( hWinBLevelM, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORBLACKM), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORBLACKM), FALSE);
			EnableWindow( hWinCorM, FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_CORM), FALSE);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_CORM), FALSE);
			
			EnableWindow( hWinLevel, sCtx.sCmd.eModeDec & DEC_AZ_START);
			EnableWindow( GetDlgItem( hDlg, IDC_DYN_LEVEL), 
										sCtx.sCmd.eModeDec & DEC_AZ_START);
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_LEVEL), 
										sCtx.sCmd.eModeDec & DEC_AZ_START);

			EnableWindow( GetDlgItem( hDlg, IDC_RADIO_FCT_AUTO), TRUE);
			EnableWindow( GetDlgItem( hDlg, IDC_RADIO_FCT_TT), TRUE);
			EnableWindow( GetDlgItem( hDlg, IDC_RADIO_FCT_TE), TRUE);

			break;

		case IDC_ABOUT :
			DialogBox( sVP.hDllInstance, "ABOUT", hDlg, (DLGPROC)bdd_about_proc);
			break;

		}

		break;
	}

	return( FALSE);

}



